// MakeRIPEMD160.h: CMakeRIPEMD160 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "MakeHashAlgorithm.h"

class CMakeRIPEMD160 : public CMakeHashAlgorithm
{
public:
    CMakeRIPEMD160();
    ~CMakeRIPEMD160();

    virtual char* GetHashName(char *pBuffer=NULL) { return (pBuffer) ? strcpy(pBuffer,"RIPEMD160") : "RIPEMD160"; }
    virtual DWORD GetHashValueSize() { return 20; }
    virtual DWORD GetHashBlockSize() { return 64; }
    virtual void Initialize();

    virtual BOOL Test();

private:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)
            { return ComputeHashHelper(pBuffer, m_pHash, len); }
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len);
    virtual void ComputeHashFinalHelper(void *msg_digest);

private:
    DWORD m_pHash[5];
};

