;***************************************************************************************************
;
; void MakeSHA256Helper_asm(const void *pBuffer, void *hash, DWORD len)
;
;***************************************************************************************************

.586
.model flat, c


;***************************************************************************************************
; MACRO

REVERSE_ENDIAN      MACRO   num
    mov eax, [esi+num]
    mov ebx, [esi+num+4]
    bswap eax
    bswap ebx
    mov [w+num], eax
    mov [w+num+4], ebx

    mov ecx, [esi+num+ 8]
    mov edx, [esi+num+12]
    bswap ecx
    bswap edx
    mov [w+num+ 8], ecx
    mov [w+num+12], edx
ENDM


PREPROCESS1      MACRO
    mov eax, [w+(14*4)]
    mov ebx, [w+( 0*4)]
    mov ecx, [w+(15*4)]
ENDM


PREPROCESS2      MACRO   num
    mov edx, [w+((num+0+16)*4-(15*4))]
    add ebx, [w+((num+0+16)*4-( 7*4))]
    mov esi, eax
    mov edi, eax
    rol esi, 32-17
    shr eax, 10
    rol edi, 32-19
    xor eax, esi
    xor eax, edi
    add eax, ebx

    mov ebx, edx
    mov esi, edx
    mov edi, edx
    ror esi, 7
    shr edx, 3
    rol edi, 32-18
    xor edx, esi
    xor edx, edi
    add eax, edx
    mov [w+((num+0+16)*4)], eax


    mov edx, [w+((num+1+16)*4-(15*4))]
    add ebx, [w+((num+1+16)*4-( 7*4))]
    mov esi, ecx
    mov edi, ecx
    shr ecx, 10
    rol esi, 32-17
    rol edi, 32-19
    xor ecx, esi
    xor ecx, edi
    add ecx, ebx

    mov ebx, edx
    mov esi, edx
    mov edi, edx
    ror esi, 7
    shr edx, 3
    rol edi, 32-18
    xor edx, esi
    xor edx, edi
    add ecx, edx
    mov [w+((num+1+16)*4)], ecx
ENDM


PREPROCESS3      MACRO   num
    PREPROCESS2 (num+0)
    PREPROCESS2 (num+2)
    PREPROCESS2 (num+4)
    PREPROCESS2 (num+6)
ENDM


SUBROUND    MACRO   a,b,c,d,e,f,g,h,num,sha256knum

; S1
; #define S1(e)           (ROTATE_R32(e, 6) ^ ROTATE_R32(e, 11) ^ ROTATE_R32(e, 25))
    mov ebp, [hash+(e*4)]
    mov eax, ebp
    mov ebx, ebp
    mov ecx, ebp
    ror eax, 6
    ror ebx, 11
    rol ecx, 32-25
    xor eax, ebx
    xor eax, ecx

; +h+k+w
    add eax, [w+(num*4)]
    add eax, [hash+(h*4)]
    add eax, sha256knum

; +ch
; #define CH(e,f,g)       ( (e&(f^g)) ^ g )
    mov ecx, [hash+(f*4)]
    mov edx, [hash+(g*4)]

    xor ecx, edx
    and ecx, ebp
    xor ecx, edx
    add eax, ecx

; d += eax
    mov ebx, [hash+(d*4)]
    add ebx, eax
    mov [hash+(d*4)], ebx

; S0
    mov ebp, [hash+(a*4)]
    mov esi, ebp
    mov edi, ebp
    mov edx, ebp
    ror esi, 2
    ror edi, 13
    rol edx, 32-22
    xor esi, edi
    xor esi, edx
    add eax, esi

; +MAJ
;#define MAJ(a,b,c)      ( ((a|b)&c) | (a&b) )

    mov edx, ebp
    mov ebx, [hash+(b*4)]
    mov ecx, [hash+(c*4)]

    or  ebp, ebx
    and edx, ebx
    and ebp, ecx
    or  edx, ebp
    add eax, edx
    mov [hash+(h*4)], eax
ENDM


ADD_HASH    MACRO   num
    mov eax, [edi +((num+0)*4)]
    mov ebx, [edi +((num+1)*4)]
    mov ecx, [hash+((num+0)*4)]
    mov edx, [hash+((num+1)*4)]
    add eax, ecx
    add ebx, edx
    mov [edi +((num+0)*4)], eax
    mov [hash+((num+0)*4)], eax
    mov [edi +((num+1)*4)], ebx
    mov [hash+((num+1)*4)], ebx
ENDM



;***************************************************************************************************
; `

; 
pBuffer equ     <esp+424>
pHash   equ     <esp+428>
len     equ     <esp+432>

; [Jϐ
w       equ     <esp>
hash    equ     <(esp+300)>

;***************************************************************************************************

.code

MakeSHA256Helper_asm    proc

    mov eax, [esp+12]       ; eax <- len
    shr eax, 6
    jnz PRE
    ret

  PRE:
    push ebp
    push ecx
    push esi
    push edi
    push ebx
    sub esp, 400
    mov [len], eax
    mov esi, [pBuffer]

    mov edi, [pHash]
    mov eax, [edi+ 0]
    mov ebx, [edi+ 4]
    mov ecx, [edi+ 8]
    mov edx, [edi+12]
    mov [hash+ 0], eax
    mov [hash+ 4], ebx
    mov [hash+ 8], ecx
    mov [hash+12], edx
    mov eax, [edi+16]
    mov ebx, [edi+20]
    mov ecx, [edi+24]
    mov edx, [edi+28]
    mov [hash+16], eax
    mov [hash+20], ebx
    mov [hash+24], ecx
    mov [hash+28], edx


  MAINLOOP:
    REVERSE_ENDIAN      0
    REVERSE_ENDIAN     16
    REVERSE_ENDIAN     32
    REVERSE_ENDIAN     48

    PREPROCESS1
    PREPROCESS3         0
    PREPROCESS3         8
    PREPROCESS3        16
    PREPROCESS3        24
    PREPROCESS3        32
    PREPROCESS3        40


    SUBROUND 0,1,2,3,4,5,6,7,  0,0428a2f98h
    SUBROUND 7,0,1,2,3,4,5,6,  1,071374491h
    SUBROUND 6,7,0,1,2,3,4,5,  2,0b5c0fbcfh
    SUBROUND 5,6,7,0,1,2,3,4,  3,0e9b5dba5h
    SUBROUND 4,5,6,7,0,1,2,3,  4,03956c25bh
    SUBROUND 3,4,5,6,7,0,1,2,  5,059f111f1h
    SUBROUND 2,3,4,5,6,7,0,1,  6,0923f82a4h
    SUBROUND 1,2,3,4,5,6,7,0,  7,0ab1c5ed5h

    SUBROUND 0,1,2,3,4,5,6,7,  8,0d807aa98h
    SUBROUND 7,0,1,2,3,4,5,6,  9,012835b01h
    SUBROUND 6,7,0,1,2,3,4,5, 10,0243185beh
    SUBROUND 5,6,7,0,1,2,3,4, 11,0550c7dc3h
    SUBROUND 4,5,6,7,0,1,2,3, 12,072be5d74h
    SUBROUND 3,4,5,6,7,0,1,2, 13,080deb1feh
    SUBROUND 2,3,4,5,6,7,0,1, 14,09bdc06a7h
    SUBROUND 1,2,3,4,5,6,7,0, 15,0c19bf174h

    SUBROUND 0,1,2,3,4,5,6,7, 16,0e49b69c1h
    SUBROUND 7,0,1,2,3,4,5,6, 17,0efbe4786h
    SUBROUND 6,7,0,1,2,3,4,5, 18,00fc19dc6h
    SUBROUND 5,6,7,0,1,2,3,4, 19,0240ca1cch
    SUBROUND 4,5,6,7,0,1,2,3, 20,02de92c6fh
    SUBROUND 3,4,5,6,7,0,1,2, 21,04a7484aah
    SUBROUND 2,3,4,5,6,7,0,1, 22,05cb0a9dch
    SUBROUND 1,2,3,4,5,6,7,0, 23,076f988dah

    SUBROUND 0,1,2,3,4,5,6,7, 24,0983e5152h
    SUBROUND 7,0,1,2,3,4,5,6, 25,0a831c66dh
    SUBROUND 6,7,0,1,2,3,4,5, 26,0b00327c8h
    SUBROUND 5,6,7,0,1,2,3,4, 27,0bf597fc7h
    SUBROUND 4,5,6,7,0,1,2,3, 28,0c6e00bf3h
    SUBROUND 3,4,5,6,7,0,1,2, 29,0d5a79147h
    SUBROUND 2,3,4,5,6,7,0,1, 30,006ca6351h
    SUBROUND 1,2,3,4,5,6,7,0, 31,014292967h

    SUBROUND 0,1,2,3,4,5,6,7, 32,027b70a85h
    SUBROUND 7,0,1,2,3,4,5,6, 33,02e1b2138h
    SUBROUND 6,7,0,1,2,3,4,5, 34,04d2c6dfch
    SUBROUND 5,6,7,0,1,2,3,4, 35,053380d13h
    SUBROUND 4,5,6,7,0,1,2,3, 36,0650a7354h
    SUBROUND 3,4,5,6,7,0,1,2, 37,0766a0abbh
    SUBROUND 2,3,4,5,6,7,0,1, 38,081c2c92eh
    SUBROUND 1,2,3,4,5,6,7,0, 39,092722c85h

    SUBROUND 0,1,2,3,4,5,6,7, 40,0a2bfe8a1h
    SUBROUND 7,0,1,2,3,4,5,6, 41,0a81a664bh
    SUBROUND 6,7,0,1,2,3,4,5, 42,0c24b8b70h
    SUBROUND 5,6,7,0,1,2,3,4, 43,0c76c51a3h
    SUBROUND 4,5,6,7,0,1,2,3, 44,0d192e819h
    SUBROUND 3,4,5,6,7,0,1,2, 45,0d6990624h
    SUBROUND 2,3,4,5,6,7,0,1, 46,0f40e3585h
    SUBROUND 1,2,3,4,5,6,7,0, 47,0106aa070h

    SUBROUND 0,1,2,3,4,5,6,7, 48,019a4c116h
    SUBROUND 7,0,1,2,3,4,5,6, 49,01e376c08h
    SUBROUND 6,7,0,1,2,3,4,5, 50,02748774ch
    SUBROUND 5,6,7,0,1,2,3,4, 51,034b0bcb5h
    SUBROUND 4,5,6,7,0,1,2,3, 52,0391c0cb3h
    SUBROUND 3,4,5,6,7,0,1,2, 53,04ed8aa4ah
    SUBROUND 2,3,4,5,6,7,0,1, 54,05b9cca4fh
    SUBROUND 1,2,3,4,5,6,7,0, 55,0682e6ff3h

    SUBROUND 0,1,2,3,4,5,6,7, 56,0748f82eeh
    SUBROUND 7,0,1,2,3,4,5,6, 57,078a5636fh
    SUBROUND 6,7,0,1,2,3,4,5, 58,084c87814h
    SUBROUND 5,6,7,0,1,2,3,4, 59,08cc70208h
    SUBROUND 4,5,6,7,0,1,2,3, 60,090befffah
    SUBROUND 3,4,5,6,7,0,1,2, 61,0a4506cebh
    SUBROUND 2,3,4,5,6,7,0,1, 62,0bef9a3f7h
    SUBROUND 1,2,3,4,5,6,7,0, 63,0c67178f2h


    mov edi, [pHash]
    ADD_HASH 0
    ADD_HASH 2
    ADD_HASH 4
    ADD_HASH 6

    mov esi, [pBuffer]
    mov eax, [len]
    add esi, 64
    sub eax, 1
    mov [pBuffer], esi
    mov [len], eax
    jnz MAINLOOP

    add esp, 400
    pop ebx
    pop edi
    pop esi
    pop ecx
    pop ebp
    ret

MakeSHA256Helper_asm    endp

end
